#include <pspsdk.h>
#include <psptypes.h>
#include <pspkernel.h>
#include <pspsystimer.h>

#include <psputilsforkernel.h>
#include <pspsysclib.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "serialport.h"
#include "rawir.h"

#define IRBUFSIZE	5*40000										// IRMobt@TCY (5bԕ)


PSP_MODULE_INFO("kBridge_Module", PSP_MODULE_KERNEL, 1, 1);
PSP_MAIN_THREAD_ATTR(0);
//PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER | PSP_THREAD_ATTR_VFPU);
//PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_VFPU);

static volatile int	gBlankTime = 400,							// t[Ԋu
					gIrStartFlag;								// L^Jn^C~Op
static volatile long gIWPosT,gIWSize;							// IRMobt@̃|C^
static volatile long gAnchor1 = 0,gAnchor2 = 0;					// AJ[|Cg
static volatile unsigned char gIrWave[IRBUFSIZE];				// IRMobt@(Oobt@)


//==============================================================
// [U[[hJ[l[h̃f[^ɃANZX֐
//--------------------------------------------------------------

//----- IRMobt@ǂݏo -----

unsigned char GetIrWave(long pos)
{
	return gIrWave[pos];
}

void ResetIrWave(void)
{
	memset( (char*)gIrWave, 0, IRBUFSIZE );
}

//----- L^Jn^C~Op -----


int GetIrStartFlag(void)
{
	return gIrStartFlag;
}

void ResetIrStartFlag(int flag)
{
	gIrStartFlag = flag;
}

//----- IRMobt@̃|C^ -----

long GetIWPosT(void)
{
	return gIWPosT;
}

long GetIWSize(void)
{
	return gIWSize;
}

void ResetIW(void)
{
	gIWPosT = 0;
	gIWSize = 0;
}

//----- AJ[|Cg -----

long GetAnchor(int no)
{
	if (no){
		return gAnchor2;
	} else {
		return gAnchor1;
	}
}

void ResetAnchor(void)
{
	gAnchor1 = 0;
	gAnchor2 = 0;
}

//==============================================================
// ԊO͂̃TvO
//--------------------------------------------------------------
// 0.025[ms]IrDA|[gǂ݁Af[^ΐԊOHÍAf[^
// LOW͂ƔfAʂgIrWave[]ɋL^܂B
// ̃TvOƒIHI͂r؂Ă܂̂ŕԏ
// ܂B
// gIrWave[]̓e
//     0 : LOW
//     1 : ԂꂽHI
//     2 : HI (M1)
//     3 : HI (M2)
//     4 : HI (M3)
//     5 : HI (M4ȏ)
// ԂHI͎̕ώM𒲂ׂΐԊOgg𐄑łƎvǁA
// ǂ낤H
// ŐṼf[^gIWPosT-1̈ʒuɂAɌgIWSizef[^
// ܂B(0Ȃf[^)
// Oobt@Ȃ̂gIWSizeIRBUFSIZEɒBĂ܂ƈԌÂ
// f[^㏑Ă܂B
//
// gIrStartFlag0̎LOWf[^͓ǂݔ΂܂B܂HI͑҂ԂłB
//
// 莞Ԉȏ̖MԂĂHI͂AMt[
// JnʒuƔfAJ[ݒuĂ܂B
// ÕAJ[ʒu獡̃AJ[ʒu܂łMt[PɂȂł
// At[̕ԂK؂ɐݒ肵ȂƂƃt[ołȂ̂
// ӂKvBit[̋󔒎Ԃ͒At[ԊԊu͒Zj
//--------------------------------------------------------------

int	timer_handler(void)
{
	static unsigned char	data[20];
	static int				len,buf[3];
	static long				pos,ancCnt = 0,ancBuf;

	len = serialport_read( data, 20,1);
	if (len) gIrStartFlag = 1;									// HI͂L^Jn
	if (gIrStartFlag){
		if (len>5) len = 5;
		buf[0] = buf[1];
		buf[1] = buf[2];
		buf[2] = len;
		if (len) len++;
		if (buf[0]!=0 && buf[1]==0 && buf[2]!=0 && gIWSize>2){	// HI͕ (HI,LOW,HI̕тɂȂLOWHIɒu)
			pos = gIWPosT - 1;
			if (pos < 0) pos += IRBUFSIZE;						// Oobt@̋E
			gIrWave[pos] = 1;
		}
		gIrWave[gIWPosT] = len;

		pos = gIWPosT - 1;										// t[̊Jnʒu
		if (pos < 0) pos += IRBUFSIZE;
		if (gIrWave[gIWPosT] != 0){
			if (gIrWave[pos] == 0){								// LOWHI
				if (ancCnt >= gBlankTime){						// LOW莞Ԉȏ㑱Ă
					ancBuf = gIWPosT;							// t[Jnʒu
				}
				ancCnt = 0;
			}
		} else {
			ancCnt++;											// LOW̎ԂJEg
			if (ancCnt == gBlankTime){							// LOW莞ԑ
				gAnchor1 = ancBuf;
				gAnchor2 = gIWPosT;								// t[IʒuɃAJ[Zbg
				if (gAnchor2 < 0) gAnchor2 += IRBUFSIZE;
			}
		}

		gIWPosT++;
		if (gIWPosT >= IRBUFSIZE) gIWPosT -= IRBUFSIZE;
		gIWSize++;
		if (gIWSize >= IRBUFSIZE) gIWSize = IRBUFSIZE;
	}
	return (-1);
}


//==============================================================
// VXe^C}[֘A
//--------------------------------------------------------------

SceSysTimerId ku_sceSTimerAlloc()
{
	/*
	int k1 = pspSdkSetK1(0);
	
	SceSysTimerId tmp = sceSTimerAlloc();
	
	pspSdkSetK1(k1);
	
	return tmp;
	*/
	
	return sceSTimerAlloc();
}


void ku_sceSTimerFree(SceSysTimerId timer)
{
	sceSTimerFree(timer);
}


void ku_sceSTimerStartCount(SceSysTimerId timer)
{
	sceSTimerStartCount(timer);
}


void ku_sceSTimerStopCount(SceSysTimerId timer)
{
	sceSTimerStopCount(timer);
}

void ku_sceSTimerResetCount(SceSysTimerId timer)
{
	sceSTimerResetCount(timer);
}

void ku_sceSTimerGetCount(SceSysTimerId timer, int* count)
{
	sceSTimerGetCount(timer,count);
}

void ku_sceSTimerSetHandler(SceSysTimerId timer, int cycle, int (*handler)(void), int unk1)
{
//	sceSTimerSetHandler(timer, cycle, handler, unk1);
	sceSTimerSetHandler(timer, cycle, timer_handler, 0);
}


void ku_sceSTimer_53231A15(SceSysTimerId timer ,int unk1)
{
	SysTimerForKernel_53231A15(timer ,unk1);
}

void ku_sceSTimer_B53534B4(SceSysTimerId timer, int unk1, int unk2)
{
	SysTimerForKernel_B53534B4(timer, unk1, unk2);
}




int module_start(SceSize args, void *argp)
{
	return 0;
}

int module_stop(void)
{
	return 0;
}


/*

typedef struct
{
	char   *buf;
	const size_t *len;
	size_t cpylen;
} xprintf_ctx;



//1邽тɌĂ΂H
static void snprnt_cb( void *ctx, int ch )
{
	if( ch == 0x200 || ch == 0x201 ) return;

	xprintf_ctx *ctx_p = (xprintf_ctx*)ctx;
	
	//Buf͈͓̔ȂRs[
	if( ctx_p->cpylen  < *(ctx_p->len) )
	{
		ctx_p->buf[ctx_p->cpylen] = ch;
		ctx_p->cpylen++;
	}
}


int vsnprintf( char *buf, size_t n, const char *fmt, va_list ap )
{
	xprintf_ctx ctx = { buf, (const size_t *)&n, 0 };
	
	prnt( snprnt_cb, (void *)&ctx, fmt, ap );
	
	if( ctx.cpylen >= *(ctx.len) )
	{
		// BufTCY𒴂
		ctx.buf[*(ctx.len) - 1] = '\0';
	}
	else
	{
		// BufTCYɎ܂Ă
		ctx.buf[ctx.cpylen] = '\0';
	}
	
	return ctx.cpylen;
}

int snprintf( char *buf, size_t n, const char *fmt, ... )
{
	va_list ap;
	int ret;
	
	va_start( ap, fmt );
	ret = vsnprintf( buf, n, fmt, ap );
	va_end( ap );
	
	return ret;
}




int Log(const char *format, ...)
{
	int k1 = pspSdkSetK1(0);
	
	va_list ap;
	char va_str[128];
	
	va_start( ap, format );
	vsnprintf( va_str,128, format, ap );
	va_end( ap );
	
	SceUID file = sceIoOpen ("ms0:/log.txt", PSP_O_WRONLY|PSP_O_APPEND|PSP_O_CREAT, 0777);
	
	if( file >= 0 )
	{
		sceIoWrite(file, va_str, strlen(va_str));
		sceIoClose(file);
	}
	
	pspSdkSetK1(k1);
	
	return 123;
}


*/


