
/* 
* Chris Mulhearn 
* 
* PSP serial port IO routines 
*/ 

// Chris Mulhearn\[`ȂłAIrDA|[gp
// AhXύXėpĂĂ܂B
// 2008/3/18 STEAR

#include "serialport.h" 


/* instantiate "serialport" that points to psp remote control serial port */ 
/* 0xBE500000 remote control */
/* 0xBE540000 IrDA */
struct serialport psprc_serialport = { 
	.txbuf = (int*)0xbe540000, 
	.rxbuf = (int*)0xbe540000, 
	.status = (int*)0xbe540018, 
	.baudh = (int*)0xBE540024,
	.baudl = (int*)0xBE540028,
	.control = (int*)0xBE54002C,
}; 

void serialport_setspeed(struct serialport * port, unsigned int baudrate) { 
	*(port->baudh) = (96000000 / baudrate) >> 6; 
	*(port->baudl) = (96000000 / baudrate) & 0x3f; 
	unsigned int x = *(port->control); 
	*(port->control) = x|0x00000006; 
}

int serialport_write(struct serialport * port, unsigned char * buffer, int length, int timeout) { 
	int tcnt, bcnt; 

	if(length <= 0) return 0; 
	bcnt = 0; 
	while(1) { 
		tcnt = 0; 
		while( (*(port->status)) & serialport_txfull) { 
			tcnt++; 
			if(tcnt > timeout) break; 
		} 
		if(tcnt > timeout) break; 
		/*if(buffer[bcnt])*/ *(port->txbuf) = buffer[bcnt]; 
		/*else *(port->txbuf) = '.'; */ 
		bcnt++; 
		if(bcnt == length) break; 
	} 
	return bcnt; 
} 

int serialport_read(struct serialport * port, unsigned char * buffer, int length, int timeout) { 
	int tcnt, bcnt; 

	if(length <= 0) return 0; 
	bcnt = 0; 
	while(1) { 
		tcnt = 0; 
		while(( (*(port->status)) & serialport_rxempty)) { 
			tcnt++; 
			if(tcnt > timeout) break; 
		} 
		if(tcnt > timeout) break; 
		buffer[bcnt] = *((char*)port->rxbuf); 
		bcnt++; 
		if(bcnt == length) break; 
	} 
	return bcnt; 
} 

